from card import Card

# You'll need the random module to shuffle the deck
import random

# Use these constant Lists to help you construct the Cards for your Deck
CARD_RANKS = ['2', '3', '4', '5', '6', '7', '8', '9', '10', 'J', 'Q', 'K', 'A']
CARD_SUITS = ['Spades', 'Clubs', 'Hearts', 'Diamonds']

# INSERT YOUR CODE AFTER THIS LINE

class Deck(object):
	"""This class models a deck of playing cards - the Deck can be shuffled,
	dealt from, and cut."""

	def __init__(self):
		"""This method initializes the Deck of cards, adding each playing card to
		the internal Card list"""
		# self.internal_card_list holds a list of cards
    		self.internal_card_list = list()
		# create two loops to go through the suits and ranks

		# use two variables a and b to go through the lists
		a = 0
		b = 0
		while(a < len(CARD_SUITS)):
			# suit will be the card suit from CARD_SUITS
			suit = CARD_SUITS[a]
			while(b < len(CARD_RANKS)):
				# rank will be the card rank from CARD_RANKS
				rank = CARD_RANKS[b]

				# make a new Card
				card = Card(rank, suit)
				# append the new Card card to the internal_card_list
				self.internal_card_list.append(card)
				b = b + 1
			a = a + 1
		return

	# assume by "current order of the Deck" that you mean the current
	# order of my self.internal_card_list
	def __str__(self):
		"""this method allows us to print out the deck of playing cards as a string
		so that we can inside of it"""
		# final is the name of the string to return to the caller
		final = str()
		# use one variable to go through the internal_card_list
		a = 0
		while(a < len(self.internal_card_list)):
		# each time i go through the loop, add the card to final
			final = final + str(self.internal_card_list[a]) + "\n"
			# add one to a
			a = a + 1
		return final

	def deal(self,num_to_deal):
		"""this method lets me deal off num_to_deal cards from the top (assume 
		0 is top)  of the deck"""
		a=0
		# use one variable for each card to deal
		while(a < num_to_deal):
			# print out the card to deal
			print str(self.internal_card_list[a])
			# add one
			a = a + 1
		# now remove the cards
		new = list()
		old_a = a
		# go through the rest of the cards and add them to a new list called new
		while(a < len(self.internal_card_list)):
			# append the card onto new
			new.append(self.internal_card_list[a])
			# add one
			a = a + 1
			#print a
			#now switch the internal_card_list with new
		self.internal_card_list = new

	def shuffle(self):
		"""this method lets me shuffle the deck of cards"""
		# found this on http://effbot.org/librarybook/random.htm - hope it's ok use
		import random
    		try:
		# available in Python 2.0 and later
			shuffle = random.shuffle
		except AttributeError:
			def shuffle(x):
				for i in xrange(len(x)-1, 0, -1):
					# pick an element in x[:i+1] with which to exchange x[i]
					j = int(random.random() * (i+1))
					x[i], x[j] = x[j], x[i]

		# shuffle the internal_card_list
	   	shuffle(self.internal_card_list)

	def cut(self):
		"""this method cuts the deck"""
		# set a to 0
		a = 0
		# b and c will be lists of cards
		b = list()
		c = list()
		# loop through to the half-part of the deck
		while(a < len(self.internal_card_list) / 2):

			# add card at a to b
			b.append(self.internal_card_lis
		
			a = a + 1

# INSERT YOUR CODE BEFORE THIS LINE

# And here's some code to test out your implementation.  You can change this if you'd like.
if __name__ == "__main__":
  d = Deck()
  d.shuffle()

  print d
  
  d.deal(10)
  
#  d.cut()

#  print d
